<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "organization_details".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "OrganizationDetails".
 *
 * Columns in table "organization_details" available as properties of the model,
 * followed by relations of table "organization_details" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property integer $send_monthly_report
 * @property string $healthgrades_api_code
 * @property integer $healthgrades_api_enabled
 * @property string $healthgrades_api_providers
 * @property string $additional_information
 * @property string $date_added
 * @property string $date_updated
 * @property string $baa_first_email_date_sent
 * @property integer $baa_email_times_sent
 * @property string $client_support_tier
 * @property integer $baa_accepted
 * @property integer $scan_template_type_id
 * @property integer $practice_only_scan
 * @property integer $allow_mass_deletion
 *
 * @property Organization $organization
 * @property ScanTemplateType $scanTemplateType
 */
abstract class BaseOrganizationDetails extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'organization_details';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'OrganizationDetails|OrganizationDetails', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('date_added, date_updated', 'required'),
            array('organization_id, send_monthly_report, healthgrades_api_enabled, baa_email_times_sent, baa_accepted, scan_template_type_id, practice_only_scan, allow_mass_deletion', 'numerical', 'integerOnly'=>true),
            array('healthgrades_api_code', 'length', 'max'=>100),
            array('additional_information', 'length', 'max'=>255),
            array('client_support_tier', 'length', 'max'=>8),
            array('healthgrades_api_providers, baa_first_email_date_sent', 'safe'),
            array('organization_id, send_monthly_report, healthgrades_api_code, healthgrades_api_enabled, healthgrades_api_providers, additional_information, baa_first_email_date_sent, baa_email_times_sent, client_support_tier, baa_accepted, scan_template_type_id, practice_only_scan, allow_mass_deletion', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, send_monthly_report, healthgrades_api_code, healthgrades_api_enabled, healthgrades_api_providers, additional_information, date_added, date_updated, baa_first_email_date_sent, baa_email_times_sent, client_support_tier, baa_accepted, scan_template_type_id, practice_only_scan, allow_mass_deletion', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'scanTemplateType' => array(self::BELONGS_TO, 'ScanTemplateType', 'scan_template_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => null,
            'send_monthly_report' => Yii::t('app', 'Send Monthly Report'),
            'healthgrades_api_code' => Yii::t('app', 'Healthgrades Api Code'),
            'healthgrades_api_enabled' => Yii::t('app', 'Healthgrades Api Enabled'),
            'healthgrades_api_providers' => Yii::t('app', 'Healthgrades Api Providers'),
            'additional_information' => Yii::t('app', 'Additional Information'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'baa_first_email_date_sent' => Yii::t('app', 'Baa First Email Date Sent'),
            'baa_email_times_sent' => Yii::t('app', 'Baa Email Times Sent'),
            'client_support_tier' => Yii::t('app', 'Client Support Tier'),
            'baa_accepted' => Yii::t('app', 'Baa Accepted'),
            'scan_template_type_id' => null,
            'practice_only_scan' => Yii::t('app', 'Practice Only Scan'),
            'allow_mass_deletion' => Yii::t('app', 'Allow Mass Deletion'),
            'organization' => null,
            'scanTemplateType' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('send_monthly_report', $this->send_monthly_report);
        $criteria->compare('healthgrades_api_code', $this->healthgrades_api_code, true);
        $criteria->compare('healthgrades_api_enabled', $this->healthgrades_api_enabled);
        $criteria->compare('healthgrades_api_providers', $this->healthgrades_api_providers, true);
        $criteria->compare('additional_information', $this->additional_information, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('baa_first_email_date_sent', $this->baa_first_email_date_sent, true);
        $criteria->compare('baa_email_times_sent', $this->baa_email_times_sent);
        $criteria->compare('client_support_tier', $this->client_support_tier, true);
        $criteria->compare('baa_accepted', $this->baa_accepted);
        $criteria->compare('scan_template_type_id', $this->scan_template_type_id);
        $criteria->compare('practice_only_scan', $this->practice_only_scan);
        $criteria->compare('allow_mass_deletion', $this->allow_mass_deletion);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
